var _excluded = ["scrollIntoView", "onTap", "onScrollToLower", "onScrollToUpper", "children", "className", "scrollWithAnimation", "showScrollbar", "onScroll", "scrollLeft", "scrollY"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, forwardRef, useRef, useImperativeHandle } from 'react';
import classNames from 'classnames';
import styles from './index.module.less';
import Visible from '../visible';
import Space from '../space'; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore

import smoothscroll from 'smoothscroll-polyfill';
smoothscroll.polyfill();
export default /*#__PURE__*/forwardRef(function (_ref, ref) {
  var scrollIntoView = _ref.scrollIntoView,
      onTap = _ref.onTap,
      onScrollToLower = _ref.onScrollToLower,
      onScrollToUpper = _ref.onScrollToUpper,
      children = _ref.children,
      className = _ref.className,
      scrollWithAnimation = _ref.scrollWithAnimation,
      _ref$showScrollbar = _ref.showScrollbar,
      showScrollbar = _ref$showScrollbar === void 0 ? true : _ref$showScrollbar,
      _onScroll = _ref.onScroll,
      scrollLeft = _ref.scrollLeft,
      scrollY = _ref.scrollY,
      props = _objectWithoutProperties(_ref, _excluded);

  useEffect(function () {
    var target = scrollIntoView && document.querySelector("#".concat(scrollIntoView));

    if (target) {
      target.scrollIntoView(scrollWithAnimation ? {
        behavior: 'smooth',
        block: 'center'
      } : false);
    }
  }, [scrollIntoView, scrollWithAnimation]);
  var domRef = useRef(null); // eslint-disable-next-line react-hooks/exhaustive-deps

  useImperativeHandle(ref, function () {
    return domRef.current;
  }, [domRef.current]);
  useEffect(function () {
    var _domRef$current;

    (_domRef$current = domRef.current) === null || _domRef$current === void 0 ? void 0 : _domRef$current.scrollTo({
      left: scrollLeft,
      behavior: scrollWithAnimation ? 'smooth' : undefined
    });
  }, [scrollLeft, scrollWithAnimation]);
  return /*#__PURE__*/React.createElement("div", _objectSpread(_objectSpread({
    className: classNames(className, styles.scroll, !showScrollbar && styles.hideBar),
    children: children,
    onMouseUp: props.onTouchEnd,
    onMouseDown: props.onTouchStart
  }, props), {}, {
    onScroll: function onScroll(_ref2) {
      var target = _ref2.target;
      return _onScroll === null || _onScroll === void 0 ? void 0 : _onScroll({
        detail: target
      });
    },
    onClick: onTap,
    ref: domRef
  }), /*#__PURE__*/React.createElement(Space, {
    flex: 1,
    justify: 'space-between',
    vertical: scrollY
  }, /*#__PURE__*/React.createElement(Visible, {
    onVisible: function onVisible() {
      return onScrollToUpper === null || onScrollToUpper === void 0 ? void 0 : onScrollToUpper({});
    }
  }), children, /*#__PURE__*/React.createElement(Visible, {
    onVisible: function onVisible() {
      return onScrollToLower === null || onScrollToLower === void 0 ? void 0 : onScrollToLower({});
    }
  })));
});